"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const axios_1 = __importDefault(require("axios"));
const Config_1 = __importDefault(require("@components/Config"));
const Toast_1 = __importDefault(require("../Toast"));
const storage_1 = require("../Fn/storage");
const react_native_device_info_1 = require("react-native-device-info");
const Fetch = (url, params = {}, extend = {}) => __awaiter(void 0, void 0, void 0, function* () {
    const opts = {
        url,
        method: (extend && (extend === null || extend === void 0 ? void 0 : extend.method)) || 'post',
        baseURL: '',
        headers: Object.assign({ 'Content-Type': 'application/json; charset=utf-8', 'X-Device-ID': (0, react_native_device_info_1.getUniqueId)() }, extend.headers),
        timeout: 30000,
        withCredentials: true,
        responseType: 'json',
        responseEncoding: 'utf8',
        maxContentLength: 2000,
    };
    const $token = yield (0, storage_1.$getStorage)('$$token');
    if ($token === null || $token === void 0 ? void 0 : $token.accessToken) {
        opts.headers = Object.assign(Object.assign({}, opts.headers), { Authorization: $token.accessToken });
    }
    if (!/http/.test(url)) {
        opts.baseURL = Config_1.default.apiHost;
    }
    else {
        opts.baseURL = '';
    }
    if ((extend === null || extend === void 0 ? void 0 : extend.post) === true) {
        opts.data = Object.assign({}, params);
        opts.headers = Object.assign(Object.assign(Object.assign({}, opts.headers), { 'content-type': 'application/json' }), (extend.headers || {}));
    }
    else {
        opts.params = Object.assign({}, params);
    }
    const ext = {
        loading: (extend && extend.loading === false) ? false : true,
        toast: (extend && extend.toast === false) ? false : true,
    };
    return new Promise((resolve, reject) => {
        (0, axios_1.default)(opts).then(res => {
            resolve(res);
        }).catch((err) => {
            console.log(`err___________${opts.baseURL + opts.url}\n`);
            if (ext === null || ext === void 0 ? void 0 : ext.toast)
                Toast_1.default.show((err === null || err === void 0 ? void 0 : err.message) || '网络繁忙，请稍后再试！');
            reject(err);
        });
    });
});
exports.default = Fetch;
