"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const react_1 = __importDefault(require("react"));
const react_native_1 = require("react-native");
const IconButton_1 = __importDefault(require("../IconButton"));
const Colors_1 = __importDefault(require("../Colors"));
const style_1 = __importDefault(require("./style"));
const react_native_2 = require("react-native");
const react_redux_1 = require("react-redux");
const NavigatorBar = ({ navigation, state, descriptors }) => {
    var _a;
    const { safeFooter } = (0, react_redux_1.useSelector)((state) => state.common);
    return (react_1.default.createElement(react_native_2.SafeAreaView, { style: Object.assign({}, safeFooter) },
        react_1.default.createElement(react_native_1.View, { style: style_1.default.container }, (_a = state === null || state === void 0 ? void 0 : state.routes) === null || _a === void 0 ? void 0 : _a.map((route, k) => {
            const { options } = descriptors[route.key];
            const isFocused = state.index === k;
            const label = options.tabBarLabel !== undefined ? options.tabBarLabel
                : options.title !== undefined
                    ? options.title
                    : route.name;
            return (react_1.default.createElement(IconButton_1.default, { key: `bar_${k}`, styleContainer: style_1.default.button, styleText: [style_1.default.label, isFocused && { color: Colors_1.default.MainColor }], type: options.iconType, name: options.iconName, color: isFocused ? Colors_1.default.MainColor : '#222', size: 24, text: label, onPress: () => {
                    return navigation.navigate(route.name);
                } }));
        }))));
};
exports.default = NavigatorBar;
